$regfile = "2313def.dat"
$baud = 9600
$crystal = 4000000

Sclpin Alias Pinb.4
Sclpout Alias Portb.4
Sdapin Alias Pinb.5
Sdapout Alias Portb.5
Config Portb = Output

Const Addr = &HEE
Const Cmd_gate_time = &H10
Const Cmd_pwm1 = &H20
Const Cmd_pwm2 = &H30
Const Cmd_control = &H40
Const Cmd_input = &H50
Const Cmd_input1 = &H00

Declare Sub Init_gatetime
Declare Sub Get_input
Declare Sub Activasi
Declare Sub Init_pwm1
Declare Sub I2c_stop
Declare Sub I2c_start
Declare Sub I2c_wbyte
Declare Sub I2c_rbyte

Dim Acc As Byte , I As Byte , Dc_data As Byte , Fack As Byte , Sub_data As Byte
Dim Inputlow As Byte , Inputhigh As Byte
Dim J As Byte

Sub_data = &H0
Call Init_pwm1
Sub_data = &H40
Call Init_gatetime
Sub_data = &B01000100
Call Activasi

For J = 0 To 5
Wait 1
Call Get_input
Print Inputlow
Print Inputhigh
Next

Sub_data = &H90
Call Init_pwm1
Sub_data = &B01000110
Call Activasi

Sub_data = &H90
While Sub_data > 10
   Sub_data = Sub_data - &H5
   Call Init_pwm1
   Waitms 500                                               'kecepatan meningkat setiap 5ms
Wend
'brake
Sub_data = 0
Call Init_pwm1
Sub_data = &B01000100                                       'arah putaran diputar balik
Call Activasi
Waitms 5
Sub_data = &B00000101                                       'motor segera dihentikan setelah
Call Activasi                                               'pengereman

End


Sub Get_input
   Call I2c_start
   Dc_data = Addr
   Call I2c_wbyte
   Dc_data = Cmd_input
   Call I2c_wbyte
   Dc_data = Cmd_input1
   Call I2c_wbyte
   Call I2c_stop
   Waitms 3
   Call I2c_start
   Dc_data = Addr Or 1
   Call I2c_wbyte
   Call I2c_rbyte
   Inputlow = Dc_data
   Call I2c_rbyte
   Inputhigh = Dc_data
   Call I2c_stop
   Waitms 3
End Sub

Sub Init_gatetime
   Call I2c_start
   Dc_data = Addr
   Call I2c_wbyte
   Dc_data = Cmd_gate_time
   Call I2c_wbyte
   Dc_data = Sub_data
   Call I2c_wbyte
   Call I2c_stop
   Waitms 3
End Sub

Sub Init_pwm1
   Call I2c_start
   Dc_data = Addr
   Call I2c_wbyte
   Dc_data = Cmd_pwm1
   Call I2c_wbyte
   Dc_data = Sub_data
   Call I2c_wbyte
   Call I2c_stop
   Waitms 3
End Sub

Sub Activasi
   Call I2c_start
   Dc_data = Addr
   Call I2c_wbyte
   Dc_data = Cmd_control
   Call I2c_wbyte
   Waitms 1
   Dc_data = Sub_data
   Call I2c_wbyte
   Call I2c_stop
   Waitms 3
End Sub

'Low Level Instruction
Sub I2c_start
   Sclpout = 0
   Sdapout = 1
   Waitus 5
   Sclpout = 1
   Waitus 5
   Sdapout = 0
   Waitus 5
End Sub

Sub I2c_stop
   Sclpout = 0
   Sdapout = 0
   Waitus 5
   Waitus 5
   Sclpout = 1
   Waitus 5
   Sdapout = 1
   Waitus 5
End Sub

Sub I2c_wbyte
   Acc = I
   For I = 7 To 0 Step -1
      Sclpout = 0
      Sdapout = Dc_data.i
      Waitus 5
      Sclpout = 1
      Waitus 5
   Next
   Sclpout = 0
   Sdapout = 1
   Waitus 5
   Sclpout = 1
   Waitus 5
   Config Sdapin = Input
   Fack.0 = Sdapin
   Config Sdapin = Output
   I = Acc
End Sub

Sub I2c_rbyte
   Acc = I
   Config Sdapin = Input
   For I = 7 To 0 Step -1
      Waitus 5
      Sclpout = 0
      Dc_data.i = Sdapin
      Waitus 5
      Sclpout = 1
      Dc_data.i = Sdapin
   Next
   Waitus 5
   Config Sdapin = Output
   Sclpout = 0
   Sdapout = 1
   Waitus 5
   Sclpout = 1
   Waitus 5
   I = Acc
End Sub